# 广告
## 广告开发备忘；
### 广告开发的各个环节采用可配置方式，在任意环节都可自定义配置；可配置的有：
  * 图片加载方式——拿到图片的文件后将文件放在ImageView等UI中显示；
  * 广告优先级排序器——当同时发现有多个未过期的有效广告时，如何排序（在配置了查找全部广告的情况下）；
  
### 广告开发流程

### 本地缓存
#### 本地缓存的数据结构
    * 缓存指定的根目录
        * 每一个广告单独一个目录
            * 广告的信息缓存Oject;命名为[广告id][".ad"]
            * 广告信息和广告图片是在同一个目录的；
            
    
#### 本地缓存其他备忘
    * 广告的图片资源命名为[广告id]["-"][图片列表序号][.pic]
    * 广告临时文件命名为[广告id]["-"][图片列表需要][.temp],全部缓存在根目录的TEMP目录下
    * 广告信息也应该temp。可以用是否包含temp和pics.size与文件数是否相同判断是否完整； 
    * 是先写图片，再写info的，要注意只有图片情况下（完成之前被中断）清理资源； 
    * 缓存前应该检查内存；
    * 出发清理后的清理规则；1、是否过期，2、有效期最短（马上过期）；（应该配置清理比较器，清理优先级比较低的）；
    * 常规巡视应该注意文件夹的遍历，不符合规则应该删除；
    

### 开发细节备忘
* 广告采用Agent方式；
* 广告的保存不分位置，只分ID；广告的广告图片命名规则为：[广告ID]-[该广告图的索引位置]
* 广告从获取，到加载、到加载完成，各个环节都应该能够设置监视器；	
* 广告要检查文件的合法性，图片的完整性，防止不能显示；
* 各个环节配置的实现应该减少外部model的依赖；
* 初始化时，至少应该分两种任务，一种是快速响应任务，获取缓存广告，一种是后台执行任务，
* 广告应该适当加密、解密数据；
* 应该写ReadMe.MD文档
* 要考虑线程被意外杀死的情况；
* 本地没有内容是，当网络结果返回时，应该准备是否回调；
* 广告应该有一个角色创建者，能够配置一些有一些特殊的角色，目前想到的应该包括：
    * 广告需求者AdDemander
        * 主要职责是向[广告创造者]描述[需求]{广告大致内容，在那里显示广告}，请求[广告创造者]创造广告；
        * [广告创造者]立即告诉[广告需求者]是否接单，并且，广告制造完成或者出现意外都要主动告诉[广告需求者]
        * [广告创造者]同意接单时，应该有[签约]行为；签约其中一项任务就是留下联系方式；
        * 可以向[广告创造者]随时询问当前进度，可以随时取消合作；
    * 广告创造者AdCreator 
        * 主要职责是根据[广告需求者]的需求设计[广告]--资源描述、描述信息能，出具广告的具体描述信息，并且和[广告施工方]签约完成工作，完成广告后通知[广告需求者]（注意：从其他地方获取广告也算是创造了广告）；
        * 在一些时间节点主动告知[广告需求者]当前进度；
        * 其与[广告施工方]签约，广告[广告施工方]具体完成广告制造工作和将广告显示到相应的[广告牌]上
        * 可以主动向[广告施工方]询问当前广告施工进度
        
    * 广告施工方AdWorker
        * 主要职责是根据[广告创造者]创造的广告信息制造出真正的广告（获取广告资源）并写显示在对应的广告牌上（可以设置是否立即显示）；
        * 主动告知[广告创造者]当前进度
        * 保存广告数据，如果下次再有相同的需求时能够立即显示；
        * 定期清理库存

### 广告的缓存应该有3种触发方式；
  * 1、是主动调用清理；
  * 2、占用空间过大时清理
  * 3、发现广告过期时清理

### 配置文件最少支持以下配置
  * 1、广告缓存最多占用多少空间，占用过多时清理资源；
  * 2、广告请求的基础地址；
  * 3、获取缓存广告（即时任务，用于立即显示到ImageView上）时，是否查找全部未过期广告，还是只要找到一个就不再找了；
  
  